; nbmjcontrols are in: src\mame\machine\nb1413m3.c

#Singleinstance, Force
StringCaseSense, On
SetWorkingDir, %A_ScriptDir%
StartTime := A_TickCount
FileRemoveDir, Data Files, 1
FileDelete, Missing Data Files.txt
FileCreateDir, Data Files 
SourcePath := "src\mame"
FileRead, Version, src\version.c
If ErrorLevel = 1
{
 MsgBox, Put src folder into:`n%A_ScriptDir%`nAnd run this program again.
 ExitApp
}
Loop, Parse, Version, `r, `n
{
 IfInString, A_LoopField, const char build_version[] =  ;const char build_version[] = "0.140 ("__DATE__")";
 {
  MameVersion := RegexReplace(A_LoopField, "[^0-9.]")

 }
}

;****************************************** Read Drivers *******************************************

Loop, %SourcePath%\drivers\*.*
{
; If A_LoopFileName In snowbros.c
 {
  Tooltip, Reading Driver: %A_LoopFileName%
  TotalDrivers++
  NumDrivers := A_Index
  Driver%A_Index% := A_LoopFileName
  FileRead, DriverText%A_Index%, %SourcePath%\drivers\%A_LoopFileName%
  DriverText%A_Index% := StreamLine(DriverText%A_Index%)
 }
}

Loop, %SourcePath%\includes\*.h
{
 Tooltip, Reading Include: %A_LoopFileName%
 TotalDrivers++
 NumIncludes := A_Index
 Include%A_Index% := A_LoopFileName
 FileRead, IncludeText%A_Index%, %SourcePath%\includes\%A_LoopFileName%
 IncludeText%A_Index% := StreamLine(IncludeText%A_Index%)
}

NumIncludes++
Include%NumIncludes% := "audio/atarijsa.h"
FileRead, IncludeText%NumIncludes%, %SourcePath%\audio\atarijsa.c
IncludeText%NumIncludes% := StreamLine(IncludeText%NumIncludes%)

NumIncludes++
Include%NumIncludes% := "megadriv.h"
FileRead, IncludeText%NumIncludes%, %SourcePath%\drivers\megadriv.c
IncludeText%NumIncludes% := StreamLine(IncludeText%NumIncludes%)

;**************************************** Begin Main Loop ******************************************

Loop, %NumDrivers%
{
 CurrentDriver := Driver%A_Index%
 Tooltip, Parsing Driver: %CurrentDriver%
 FileDelete, TempFile\TempDriver.txt   ; Used For Trouble Shooting
 
;***************************************** File Includes *******************************************

 Flag = 0
 DriverSrc := DriverText%A_Index%
 Loop, Parse, DriverText%A_Index%, `n
 {
  LoopField = %A_LoopField%
  IfInString, Loopfield, #include
  {
   IfInString, LoopField, /
   {
    If Loopfield Not Contains drivers/,audio/atarijsa.h
     Continue
   }
   If Loopfield Not Contains driver.h,deprecat.h
   {
    StringSplit, TempVar, LoopField, `"
    StringReplace, TempVar2, TempVar2, drivers`/,, all
    IfInString, TempVar2, `.c
    {
     Loop, %NumDrivers%
     {
      If Driver%A_Index% = %TempVar2%
      {
       TempVar := DriverText%A_Index%
       Break
      }
     }
    }
    Else
    {
     Loop, %NumIncludes%
     {
      If Include%A_Index% = %TempVar2%
      {
       TempVar := IncludeText%A_Index%
       Break
      }
     }
    }
    If Flag = 0
       DriverSrc = %TempVar%%DriverSrc%
    Else
      DriverSrc .= TempVar
    Continue
   }
  }
  IfInString, Loopfield, INPUT_PORTS_START
    Flag = 1
 }

 FileAppend, %DriverSrc%, TempFile\TempDriver.txt   ; Used For Trouble Shooting

;****************************************** Parse Driver *******************************************

 LineCount = 0
 NumParents = 0
 NumDefines = 0
 Flag = 0
 GameList =
 Loop, Parse, DriverSrc, `n
 {
  TotalLineCount++
  Linecount++
  StringReplace, LoopField, A_LoopField, %A_Space%,, All
  StringReplace, LoopField, LoopField, \,, All
  
  If A_LoopField Contains PORT_START,PORT_MODIFY,INPUT_PORTS_END,PORT_INCLUDE
  {
   If DipFlag = 97
   {
    ParentText%NumParents% .= Minimum . Maximum
   }
   ParentText%NumParents% .= "!@#`n"
   PortModify = 0
   DipFlag = 0
   Maximum =
   DipParam =
  }

  If LoopField =
  {
   If Define = 1
   {
    Flag = 0
    Define = 0
   }
   Continue
  }

  IfInString, LoopField, INPUT_PORTS_END
  {
   Flag = 0
   Continue
  }
  
  IfInString, LoopField, PORT_DIPUNUSED
    Continue

;**************************************** Find Input Ports *****************************************

  If Flag = 1
  {


;	PORT_START("IN0")

   IfInString, LoopField, PORT_START("
   {
    StringSplit, TempVar, A_Loopfield, "
    Port = PORT_START("%TempVar2%")
    ParentText%NumParents% .= Port . "`n"
    Continue
   }

;	PORT_START(INVADERS_P1_CONTROL_PORT_TAG) \

   IfInString, LoopField, PORT_START(
   {
    StringReplace, TempVar, Loopfield, (, |, All
    StringReplace, TempVar, TempVar, ), |, All
    StringSplit, TempVar, TempVar, |
    Loop, %NumDefines%
    {
     If OldDefine%A_Index% = %TempVar2%
     {
      TempVar := NewDefine%A_Index%
      Port = PORT_START("%TempVar%")
      ParentText%NumParents% .= Port . "`n"
;msgbox, % ParentText%NumParents%
;MsgBox, %LineCount%`n%LoopField%`n%Port%
      Break
     }
    }
;MsgBox, %LineCount%`n%LoopField%`n%Port%
    Continue
   }

;PORT_START		/* IN0 */    ;Older Versions

   IfInString, LoopField, PORT_START/
   {
    StringSplit, TempVar, Loopfield, *
    Port = PORT_START("%TempVar2%")
    ParentText%NumParents% .= Port . "`n"
;MsgBox, % ParentText%NumParents%
    Continue
   }

;	PORT_MODIFY("P1")

   IfInString, Loopfield, PORT_MODIFY
   {
    PortModify = 1
    StringSplit, TempVar, A_Loopfield, "
    ModifyPort = PORT_START("%TempVar2%")
;msgbox, %LineCount%`nPort Modify=%ModifyPort%*
    Continue
   }


;	PORT_INCLUDE( sicv )

   IfInString, Loopfield, PORT_INCLUDE
   {
    StringReplace, TempVar, Loopfield, (, |, All
    StringReplace, TempVar, TempVar, ), |, All
    StringSplit, TempVar, TempVar, |
    Loop, %NumParents%
    {
;msgbox, TempVar2 . "`n" . Parent%A_Index%
     If Parent%A_Index% = %TempVar2%
     {
      ParentText%NumParents% .= ParentText%A_Index%
;msgBox, % TempVar97 . "`n" . TempVar2 . "`n" . ParentText%A_Index%
      Break
     }
    }
    Continue
   }


; KONAMI_PLAYERS_INPUT_LSB( 1, IPT_BUTTON3, IPT_BUTTON4 ) PORT_PLAYER(1)  ;tmnt.c
;KONAMI_PLAYERS_INPUT_LSB( 1, IPT_BUTTON3, IPT_UNUSED )
;INVADERS_CONTROL_PORT_PLAYER(1)  ;8080bw.c
;NAMCO_56IN0

   If LoopField Not Contains 0x  ;Port Include
   {
    TempVar3 =
    StringReplace, TempVar, Loopfield, (, |
    StringReplace, TempVar, TempVar, ), |
    StringSplit, TempVar, TempVar, |
    StringSplit, NewParam, TempVar2, `,
    StringTrimRight, TempVar3, TempVar3, 1
    If TempVar3 <>
    NewParam%NewParam0% .= ")" . TempVar3
    Loop, %NumParents%
    {
     If Parent%A_Index% = %TempVar1%
     {
      Count := A_Index
      TempText := ParentText%A_Index%
      Loop, %NewParam0%
      {
       OldParam := OldParam%Count%%A_Index%
       NewParam := NewParam%A_Index%
       If OldParam =PL
       {
        OldParam=(PL)
        NewParam =(%NewParam%)
       }
       StringReplace, TempText, TempText, %OldParam% , %NewParam%, All
      }
      ParentText%NumParents% .= TempText . "`n"
;msgBox, % LineCount . "`nPortInclude=" . LoopField . "`n" . Parent%NumParents% . "`n" . ParentText%NumParents%
      Break
     }
    }
    Continue
   }


; Original>	    PORT_BIT( 0x01, IP_ACTIVE_LOW, IPT_JOYSTICK_LEFT ) PORT_4WAY
;Replacement> 	PORT_BIT( 0x01, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2)

   If PortModify = 1
   {
    IfNotInString, Loopfield, PORT_DIP
    {
;FileAppend, % ParentText%NumParents%, TempFile\Temp.txt
;msgbox, % ParentText%NumParents%
     StringSplit, PortBit, LoopField, `,
     StringSplit, HexNum, PortBit1, (
     StringGetPos, Pos1, ParentText%NumParents%, %ModifyPort%
     Pos1++
     StringGetPos, Pos2, ParentText%NumParents%, !@#,, %Pos1%
     StringMid, OldStr, ParentText%NumParents%, %Pos1%, Pos2 - Pos1
;msgBox, %OldStr%
     NewStr = 
     NewFlag = 0
     Loop, Parse, OldStr, `n
     {
      IfInString, A_LoopField, %HexNum2%
      {
       NewFlag = 1
       NewStr .= LoopField . "`n"
      }
      Else
        NewStr .= A_LoopField . "`n"
     }
     If NewFlag = 0
        NewStr .= LoopField
     StringReplace, ParentText%NumParents%, ParentText%NumParents%, %OldStr%, %NewStr%
;msgbox, % LineCount . "`n" . ModifyPort . "`n" . %LoopField . "`n" . HexNum2 . "`n" . ParentText%NumParents% . "`n" . NewStr
     Continue
    }
   }


   StringLeft, TempVar, LoopField, 12
   IfNotInString, TempVar, PORT_DIP
   {
   ParentText%NumParents% .= Loopfield . "`n"
    Continue
   }

;****************************************** Dip Switches *******************************************

;	PORT_DIPNAME( 0x04, 0x04, DEF_STR( Cabinet ) )\
; PORT_DIPNAME( 0x0040, 0x0040, DEF_STR( Free_Play ) )
; PORT_DIPNAME( 0x07, 0x07, DEF_STR( Coin_A ) )

   IfInString, LoopField, PORT_DIPNAME
   {
    If DipFlag = 97
    {
     ParentText%NumParents% .= Minimum . Maximum
    }
    DipFlag = 0
    Maximum =
    DipParam =
    IfInString, LoopField, Cabinet
    {
     DipFlag = 1
     DipField := LoopField
     Continue
    }
    IfInString, LoopField, Free
    {
     DipFlag = 2
     DipField := LoopField
     Continue
    }
    IfInString, LoopField, Coin
    {
     DipFlag = 3
     DipField := LoopField
     Continue
    }
    IfInString, LoopField, Language
    {
     DipFlag = 98
     DipType := "LANGUAGE|"
     DipField := LoopField
     DipParam =
     Continue
    }
    IfInString, LoopField, Difficulty
    {
     DipFlag = 97
     Maximum =
     DipType := "DIFFICULTY|"
     DipField := LoopField
     DipParam := "MIN|"
     Continue
    }
    IfInString, LoopField, Lives
    {
     DipFlag = 97
     Maximum =
     DipType := "LIVES|"
     DipField := LoopField
     DipParam := "MIN|"
     Continue
    }
    IfInString, LoopField, Bonus_Life
    {
     DipFlag = 97
     Maximum =
     DipType := "BONUS_LIFE|"
     DipField := LoopField
     DipParam := "MIN|"
     Continue
    }
   }

;	PORT_DIPSETTING(    0x00, DEF_STR( Cocktail ) )\
; PORT_DIPSETTING(	  0x0000, DEF_STR( On ) )
;	PORT_DIPSETTING(    0xe0, DEF_STR( Free_Play ) )

   If DipFlag = 1
   {
    IfInString, LoopField, Cocktail
    {
     DipFlag = 99
     DipType := "COCKTAIL|"
    }
   }
   If DipFlag = 2
   {
    IfInString, LoopField, On
    {
     DipFlag = 99
     DipType := "FREEPLAY|"
    }
   }
   If DipFlag = 3
   {
    IfInString, LoopField, Free_Play
    {
     DipFlag = 99
     DipType := "FREEPLAY|"
    }
   }

;PORT_DIPSETTING (	0x00, DEF_STR( English ) )
   If DipFlag > 90
   {
    If DipFlag = 99
       DipFlag = 0
    StringSplit, Port, Port, ""
    StringSplit, Field, Dipfield, `,
    StringSplit, Mask, Field1, (
    Mask2 += 0
    Field2 += 0
    StringSplit, TempVar, LoopField, `,
    StringSplit, Value, TempVar1, (
    
    If DipFlag = 98
    {
     StringReplace, TempVar2, TempVar2, (, |
     StringReplace, TempVar2, TempVar2, ), |
     StringSplit, TempVar, TempVar2, |
     DipParam := TempVar2 . "|"
    }
     
    Value2 += 0
    TempVar = %DipType%%DipParam%<port tag=":%Port2%" type="DIPSWITCH" mask="%Mask2%" defvalue="%Field2%" value="%Value2%" />`n
    If DipFlag = 97
    {
     If Maximum =
     {
      Minimum := TempVar
      DipParam := "MAX|"
     }
     Maximum := TempVar
    }
    Else
     ParentText%NumParents% .= TempVar

   }
  }  ; End "If Flag = 1"

; **************************************** Find Next Port*******************************************

  If Flag = 0
  {


   If LoopField Contains GAME(,GAMEL(,GAME (
   {
    GameList .= LoopField  . "`n"
    Continue
   }


;   #define KONAMI_PLAYERS_INPUT_MSB( player, button3, start ) \
;   #define INVADERS_CONTROL_PORT_P1 \   ;8080bw.c

   IfInString, Loopfield, #define
   {

    IfInString, A_LoopField, \
    {
     Define = 1
     TempVar2 =
     Flag = 1
;msgBox, % Parent%NumParents% . "`n" . Parent%NumParents%
     NumParents++
     StringReplace, TempVar, Loopfield, (, |
     StringReplace, TempVar, TempVar, ), |
     StringSplit, TempVar, TempVar, |
     StringTrimLeft, TempVar1, TempVar1, 7
     If TempVar2 <>
     {
      StringSplit, OldParam%NumParents%, TempVar2, `,
     }
;msgbox, %TempVar1%
     Parent%NumParents% = %TempVar1%
     ParentText%NumParents% =
     continue
     }
     
;   #define INVADERS_P1_CONTROL_PORT_TAG	("CONTP1")  ;8080bw.c
;   #define P1TRACKX_PORT_TAG     "P1X"
;	  PORT_START(P1TRACKX_PORT_TAG)

     Else
     {
      NumDefines++
      StringSplit, TempVar, A_LoopField, %A_Space%
      OldDefine%NumDefines% = %TempVar2%
      StringSplit, TempVar, LoopField, ""
      NewDefine%NumDefines% = %TempVar2%
TempVar99 := A_LoopField
TempVar98 := OldDefine%NumDefines%
;msgbox, LoopField=%TempVar99%`nOldDefine=%TempVar98%`nNewDefine=%TempVar2%
     }
    Continue
   }


;   static INPUT_PORTS_START( superpac )

   IfInString, Loopfield, INPUT_PORTS_START
   {
    Flag = 1
;msgBox, % Parent%NumParents% . "`n" . ParentText%NumParents%
    NumParents++
    StringReplace, TempVar, Loopfield, (, |, All
    StringReplace, TempVar, TempVar, ), |, All
    StringSplit, TempVar, TempVar, |
    Parent%NumParents% = %TempVar2%
    ParentText%NumParents% =
    Continue
   }
  }  ; End "If Flag = 0"
 } ; End "Loop, Parse, DriverSrc, `n

;********************************** End of Driver - Convert Data ***********************************

 Loop, %NumParents%
 {
;FileDelete, TempFile\ParentText.txt  ; Used For Trouble Shooting
;FileAppend, % ParentText%A_Index%, TempFile\ParentText.txt
  LoopCount := A_Index
  CfgText%LoopCount%=
  Loop, Parse, ParentText%LoopCount%, `n
  {
   LoopField = %A_Loopfield%

   IfInString, Loopfield, DIPSWITCH
   {
    CfgText%LoopCount% .= LoopField . "`n"
    Continue
   }

   If LoopField = "!@#"
   {
    Continue
   }

;	PORT_START("IN2")

   IfInString, Loopfield, PORT_START
   {
    StringSplit, Port, LoopField, ""
    Continue
   }
   

   IfInString, Loopfield, PORT_BIT(                        ;*************** Inputs ****************
   {
    StringReplace, LoopField, LoopField, #,, All
    If Loopfield Contains IPT_BUTTON,IPT_JOYSTICK,IPT_AD_STICK,IPT_DIAL,IPT_LIGHTGUN
                          ,IPT_MOUSE,IPT_PADDLE,IPT_PEDAL,IPT_POSITIONAL,IPT_TRACKBALL,IPT_PADDLE
    {
     P = 1
     If Loopfield Contains PORT_COCKTAIL,PORT_PLAYER(2),PORT_PLAYER(_2_),IPF_PLAYER2
       P = 2
     If Loopfield Contains PORT_PLAYER(3),PORT_PLAYER(_3_),IPF_PLAYER3
       P = 3
     If Loopfield Contains PORT_PLAYER(4),PORT_PLAYER(_4_),IPF_PLAYER4
       P = 4
     If Loopfield Contains PORT_PLAYER(5),PORT_PLAYER(_5_),IPF_PLAYER5
       P = 5
     If Loopfield Contains PORT_PLAYER(6),PORT_PLAYER(_6_),IPF_PLAYER6
       P = 6
       
;	PORT_BIT( 0x02, IP_ACTIVE_LOW,	IPT_BUTTON1 ) PORT_COCKTAIL
;	PORT_BIT( 0xff, 0x80, IPT_LIGHTGUN_X )
;	PORT_BIT( 0xff, 0, IPT_TRACKBALL_Y ) PORT_SENSITIVITY(10) PORT_KEYDELTA(50) PORT_PLAYER(1)
;	PORT_BIT( 0x01ff, 400 + 4, IPT_LIGHTGUN_X )  ; targeth.c
; PORT_BIT( 0x01, IP_ACTIVE_LOW, IPT_JOYSTICK_UP | IPF_PLAYER2 ) ; Old Versions

     StringSplit, Field, Loopfield, `,
     StringSplit, DefValue, Field1, (
     Mask := DefValue2
     Mask += 0
     IfInString, Field2, +
     {
      StringSplit TempVar, Field2, +
      DefValue := TempVar1 + TempVar2
     }
     Else If Field2 = IP_ACTIVE_HIGH
        DefValue = 0
     Else If Field2 = IP_ACTIVE_LOW
        DefValue := DefValue2
     Else If Field2 Is Xdigit
      DefValue := Field2

     DefValue += 0
     If DefValue = 2147483648
        Defvalue = -2147483648
     If Mask = 2147483648
        Mask = -2147483648
     StringSplit, Control, Field3, )
     StringSplit, Control, Control1, |
     StringTrimLeft, Control, Control1, 3
     Control = %Control%
     TempVar=<port tag=":%Port2%" type="P%P%%Control%" mask="%Mask%" defvalue="%DefValue%">
;Msgbox, %LoopField%`n%TempVar%
     IfNotInString, CfgText%LoopCount%, %TempVar%
       CfgText%LoopCount% .= TempVar . "`n"
    }
   }
  }
;MsgBox, % Parent%LoopCount% . "`n" . ParentText%LoopCount% . "`n" . CFGText%LoopCount%
 }

;******************************************* Write CFGs ********************************************
  
 Loop, Parse, Gamelist, `n
 {
  If A_LoopField <>
  {
   StringSplit, TempVar, A_LoopField, `,, %A_Space%
   IfInString, A_LoopField, GAME_NOT_WORKING
   {
    MissingFiles .= TempVar2 . "|"   ; . " - GAME_NOT_WORKING`n"
    TempVar := SubStr(TempVar2 . "          ",1,12)
    NotWorking .= TempVar . CurrentDriver . "`n"
    Continue
   }
   Loop, %NumParents%
   {
    If Parent%A_Index% = %TempVar5%
    {
     If CfgText%A_Index% =
     {
      MissingFiles .= Tempvar2 . "|"   ; . " - NO_MATCHING_CONTROLS`n"
      TempVar := SubStr(TempVar2 . "          ",1,12)
      NoControls .= TempVar . CurrentDriver . "`n"
      Break
     }
     FileAppend, % CfgText%A_Index%, Data Files\%TempVar2%.cfg
     Break
    }
   }
  }
 }
 
 
} ;***** End "Loop, %NumDrivers%"

;******************************************** End Main Loop ****************************************

FileAppend, %MissingFiles%, Missing Data Files.txt
FileAppend, %NotWorking%, Data Files\Mame %MameVersion% Not Working.txt
FileAppend, %NoControls%, Data Files\Mame %MameVersion% No Controls.txt
FileMoveDir, Data Files, Mame %MameVersion% Data Files, R
FileMoveDir, src, %MameVersion% src, R
;FileDelete, TempFile\TempDriver.txt  ; Used For Trouble Shooting

ElapsedTime := (A_TickCount - StartTime)/1000
Tooltip
MsgBox, %TotalDrivers% Drivers`nContaining %TotalLineCount% Lines`nParsed in %ElapsedTime% seconds.
ExitApp
Esc::ExitApp

StreamLine(StringName)
{
 Global
 StringName := RegExReplace(StringName, "s)#if USE_FAKE_INPUT_PORTS.+?#else", "") ;mugsmash.c
 StringName := RegExReplace(StringName, "s)\r\s+(?=PORT_CODE)", "") ;glfgreat?
 StringName := RegExReplace(StringName, "s)static ADDRESS_MAP_START.+?ADDRESS_MAP_END", "")
 StringName := RegExReplace(StringName, "s)ROM_START.+?ROM_END", "")
 StringName := RegExReplace(StringName, "s)static MACHINE_DRIVER_START.+?MACHINE_DRIVER_END", "")
 StringName := RegExReplace(StringName, "static.+?\)(?=\r\n{)", "")    ; Static ( text) with next line {
 StringName := RegExReplace(StringName, "s)\{.+?}.+?", "")           ; { Useless Text }  ; multiline
 StringName := RegExReplace(StringName, "s)/\*.+?\*/", "")             ; /* this is a comment */  ; multiline
 StringName := RegExReplace(StringName, "//.+?\r", "")                 ; // this is also a comment
 StringName := RegExReplace(StringName, ".+?[;=]\r", "")             ; any line ending in ; or =
 StringReplace, StringName, StringName, },, all
 StringReplace, StringName, StringName, %A_Tab%, %A_Space%, all
 StringReplace, StringName, StringName, `r,, all
 StringName := RegExReplace(StringName, "\n\\\n", "`n")                       ; findout.c
 Loop
 {
  StringReplace, StringName, StringName, `n`n`n, `n`n, UseErrorLevel
  If ErrorLevel = 0
     Break
 }
 Loop
 {
  StringReplace, StringName, StringName, %A_Space%%A_Space%, %A_Space%, UseErrorLevel
  If ErrorLevel = 0
     Break
 }
Return, StringName
}